//
//  MadvertiseCustomEventNativead.m
//  DFPAdapter
//
//  Created by MacBook Pro on 02/10/2019.
//  Copyright © 2019 MacBook Pro. All rights reserved.
//

#import "MadvertiseCustomEventNativead.h"

@interface MadvertiseCustomEventNativead () <MNGAdsAdapterNativeDelegate,MNGClickDelegate> {
    /// Native ad view options.
    GADNativeAdViewAdOptions *_nativeAdViewAdOptions;
    MNGAdsSDKFactory * _nativeFactory;
}

@end

@implementation MadvertiseCustomEventNativead

@synthesize delegate;
id<NativeAdMadvertiseDFPDelegate>  _customDFPDelegate;

UIView * _nativeView;
UIImageView * _mainImageView;
UIImageView * _iconImageView;
UIButton* _callToActionLabel;
UIViewController* _viewController;
UILabel * _titleLabel;
UILabel * _mainTextLabel;


+(void)setMainImage:(UIImageView*)mainImage andIconeImage:(UIImageView*) iconImage andNativeView:(UIView*)nativeView andButton:(UIButton*)callToActionLabel andWithViewController:(UIViewController*)viewController andTitleLabel:(UILabel*)titleLabel andMainLabel:(UILabel*)mainLabel {
    _mainImageView = mainImage;
    _iconImageView = iconImage;
    _nativeView = nativeView;
    _callToActionLabel = callToActionLabel;
    _viewController = viewController;
    _titleLabel = titleLabel;
    _mainTextLabel = mainLabel;
}


+(void)setNativeAdMadvertiseDFPDelegate:(id<NativeAdMadvertiseDFPDelegate>)delegate{
    _customDFPDelegate = delegate;
}


#pragma mark - GADCustomEventNativeAd protocol methods

- (void)requestNativeAdWithParameter:(NSString *)serverParameter
                             request:(GADCustomEventRequest *)request
                             adTypes:(NSArray *)adTypes
                             options:(NSArray *)options
                  rootViewController:(UIViewController *)rootViewController {
    BOOL requestedUnified = [adTypes containsObject:kGADAdLoaderAdTypeUnifiedNative];
    
    // This custom event assumes you have implemented unified native advanced in your app as is done
    // in this sample.
    
    if (!requestedUnified) {
        NSString *description = @"You must request the unified native ad format.";
        NSDictionary *userInfo =
        @{NSLocalizedDescriptionKey : description, NSLocalizedFailureReasonErrorKey : description};
        NSError *error =
        [NSError errorWithDomain:@"com.google.mediation.sample" code:0 userInfo:userInfo];
        [self.delegate customEventNativeAd:self didFailToLoadWithError:error];
        return;
    }
    
    // This custom event uses the server parameter to carry an ad unit ID, which is the most common
    // use case.
    if (_nativeFactory != nil) {
        [_nativeFactory releaseMemory];
        _nativeFactory = nil;
    }
    NSString *appID = [self getAppIdByPlacementFromServerParameter:serverParameter];
    [MNGAdsSDKFactory initWithAppId:appID];
    _nativeFactory = [[MNGAdsSDKFactory alloc]init];
    _nativeFactory.nativeDelegate = self;
    _nativeFactory.viewController = _viewController;
    _nativeFactory.placementId =  serverParameter ; //_nativePlacement;
    _nativeFactory.clickDelegate = self;
    
    MNGPreference *preferences = [[MNGPreference alloc]init];
    CLLocation *locationRequest = [[CLLocation alloc] initWithLatitude:request.userLatitude longitude:request.userLongitude];
    preferences.location = locationRequest;
    preferences.keyWord= [self createMngPreferenceKeyWord:request];
    [_nativeFactory loadNativeWithPreferences:preferences];
}

-(NSString*)createMngPreferenceKeyWord:(GADCustomEventRequest *)request{
    NSString* keyWord = @"";
    NSString* userRequest = @"";
    NSString*  requestExtrasString = @"";
    if (request.userKeywords.count == 1) {
        userRequest = [request.userKeywords[0] stringByAppendingString:@";"];
    }
    if (request.additionalParameters != nil) {
        requestExtrasString = [NSString stringWithFormat:@"%@", request.additionalParameters];
        requestExtrasString = [requestExtrasString stringByReplacingOccurrencesOfString:@"{"withString:@""];
        requestExtrasString = [requestExtrasString stringByReplacingOccurrencesOfString:@"}"withString:@""];
        requestExtrasString = [requestExtrasString stringByReplacingOccurrencesOfString:@"\n"withString:@""];
        requestExtrasString = [requestExtrasString stringByReplacingOccurrencesOfString:@" "withString:@""];
        NSString *lastChar = [requestExtrasString substringFromIndex:[requestExtrasString length] - 1];
        if ([lastChar isEqualToString:@";"]){
            requestExtrasString = [requestExtrasString substringToIndex:[requestExtrasString length] - 1];
        }
    }
    keyWord = [userRequest stringByAppendingString:requestExtrasString];
    return keyWord;
}
- (BOOL)handlesUserClicks {
    return NO;
}


- (BOOL)handlesUserImpressions {
    return NO;
}


#pragma mark - NativeAdMNG  protocol methods


-(void)adsAdapter:(MNGAdsAdapter *)adsAdapter nativeObjectDidLoad:(MNGNAtiveObject *)adView{
    if ([_customDFPDelegate respondsToSelector:@selector(madvertiseCustomEventNativeAdidReceiveAd:)]) {
        [_customDFPDelegate madvertiseCustomEventNativeAdidReceiveAd:adView];
    }
}


- (void)adsAdapter:(MNGAdsAdapter *)adsAdapter nativeObjectDidFailWithError:(NSError *)error{
    if ([_customDFPDelegate respondsToSelector:@selector(madvertiseCustomEventNativeAd:didFailToLoadWithError:)]) {
        [_customDFPDelegate madvertiseCustomEventNativeAd:self didFailToLoadWithError:error];
    }
}

- (NSString * )getAppIdByPlacementFromServerParameter:(NSString  *)serverParameter {
    NSString * appID;
    if (serverParameter != nil) {
        NSArray *items = [serverParameter componentsSeparatedByString:@"/"];
        if (items.count >= 2) {
          appID  =[items objectAtIndex:1];
        }
    }
    return appID;
}

- (void)dealloc{
    if (_nativeFactory) {
        _nativeFactory = nil;
    }
}
@end
